unit unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, ComCtrls, OpenGLContext, gl;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    OpenGLControl1: TOpenGLControl;
    textureID: array[0..127 - 32] of GLuint;
  public
  end;

var
  Form1: TForm1;

implementation

procedure TForm1.Timer1Timer(Sender: TObject);
const
  hello: PChar = 'Hello World !';

  procedure Draw(size: GLfloat);
  begin
    glBegin(GL_QUADS);
    glColor3f(1.0, 1.0, 1.0);
    glTexCoord2f(0.0, 1.0);
    glVertex3f(-size, -size, 0);
    glTexCoord2f(0.0, 0.0);
    glVertex3f(-size, size, 0);
    glTexCoord2f(1.0, 0.0);
    glVertex3f(size, size, 0);
    glTexCoord2f(1.0, 1.0);
    glVertex3f(size, -size, 0);
    glEnd();
  end;

const
  winkel: GLfloat = 0;
var
  i: integer;
begin
  winkel += 1.1;

  glClearColor(0.8, 0.5, 0.3, 1.0);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glEnable(GL_DEPTH_TEST);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glScalef(0.1, 0.1, 1.0);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glEnable(GL_TEXTURE_2D);

  for i := 0 to Length(hello) - 1 do begin
    glPushMatrix;
    glRotatef(winkel, 0.0, 0.0, 1.0);
    glBindTexture(GL_TEXTURE_2D, textureID[byte(hello[i]) - 32]);
    glTranslatef(i, 0.0, 0.0);
    Draw(0.4);
    glPopMatrix;
  end;

  glDisable(GL_TEXTURE_2D);

  OpenGLControl1.SwapBuffers;
end;


procedure TForm1.FormCreate(Sender: TObject);
var
  bit: tbitmap;
  i: integer;
begin
  OpenGLControl1 := TOpenGLControl.Create(Self);
  OpenGLControl1.Parent := Self;
  OpenGLControl1.Align := alClient;
  OpenGLControl1.AutoResizeViewport := True;
  OpenGLControl1.MakeCurrent;

  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

  glGenTextures(Length(textureID), @textureID);

  glEnable(GL_DEPTH_TEST);
  glDepthFunc(GL_LESS);

  bit := TBitmap.Create;
  for i := 0 to Length(textureID) - 1 do begin
    bit.Clear;
    bit.SetSize(16, 16);
    bit.Canvas.TextOut(0, 0, char(i + 32));
    with bit do begin
      glBindTexture(GL_TEXTURE_2D, textureID[i]);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);

      {$IFDEF Linux}
      glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, Width, Height, 0, GL_RGBA, GL_UNSIGNED_BYTE, RawImage.Data);
      {$ENDIF}

      {$IFDEF Windows}
      glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, Width, Height, 0, GL_RGB, GL_UNSIGNED_BYTE, RawImage.Data);
      {$ENDIF}
    end;
  end;
  bit.Free;

  Timer1.Enabled := True;
  Timer1.Interval := 40;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  glDeleteTextures(Length(textureID), @textureID);
end;

initialization

  {$I unit1.lrs}

end.
